class Counter {
    protected int x = 0;
    public int get() { return x; }
    public void inc() { x++; }
}

class Util {
    public static void inc3(Counter c) {
	      c.inc(); c.inc(); c.inc();
    }
}

class ResetCounter extends Counter {
    public void reset() { x = 0; }
}

class BackupCounter extends ResetCounter {
    protected int b = 0;
    public void backup() { b = x; }
}

class SetCounter {
    protected int x = 0;
    public int get() { return x; }
    public void set(int i) { x = i; }
    public void inc() {
        this.set(this.get() + 1);
    }
}

class InstrCounter extends SetCounter {
    protected int a = 0;
    public int accesses() { return a; }
    public void set(int i) {
        a++;
        super.set(i);
    }
}
